'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var classnames = require('classnames');
var utilsCommons = require('@highlight-ui/utils-commons');
var Icon = require('@highlight-ui/icon');
var Button = require('@highlight-ui/button');
var utilsHooks = require('@highlight-ui/utils-hooks');
var utilsPortalManager = require('@highlight-ui/utils-portal-manager');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);
var Icon__default = /*#__PURE__*/_interopDefaultLegacy(Icon);
var Button__default = /*#__PURE__*/_interopDefaultLegacy(Button);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

var styles$3 = {"actionsContainer":"Actions-module__Ds9CWwoq__v1-0-1"};

function ActionsWithRef(_a, ref) {
    var children = _a.children;
    return (React__default['default'].createElement("div", { className: styles$3.actionsContainer, ref: ref }, children));
}
ActionsWithRef.displayName = 'Actions';
var Actions = React__default['default'].forwardRef(ActionsWithRef);

var styles$2 = {"alertContainer":"Alert-module__3OKHdEQO__v1-0-1","alertInner":"Alert-module__3Qwn6Uqc__v1-0-1","alertInner-default":"Alert-module__2astVrX0__v1-0-1","alertInner-info":"Alert-module__3l1eJk7E__v1-0-1","alertInner-success":"Alert-module__3CyiOT7l__v1-0-1","alertInner-warning":"Alert-module__eRD2yA1G__v1-0-1","alertInner-danger":"Alert-module__oIWxCVfr__v1-0-1","alertContent":"Alert-module__9Wb2FGGa__v1-0-1","icon":"Alert-module__3yvNKTSf__v1-0-1","alertFullWidth":"Alert-module__o_Ml_MUW__v1-0-1","alertCloseButton":"Alert-module__bTXZ4-X9__v1-0-1"};

function AlertWithRef(_a, ref) {
    var _b, _c;
    var _d;
    var actions = _a.actions, children = _a.children, className = _a.className, _e = _a.enableCloseButton, enableCloseButton = _e === void 0 ? false : _e, _f = _a.fullWidth, fullWidth = _f === void 0 ? false : _f, iconColor = _a.iconColor, _g = _a.iconFamily, iconFamily = _g === void 0 ? 'solid' : _g, iconName = _a.iconName, _h = _a.iconSize, iconSize = _h === void 0 ? 16 : _h, iconClassName = _a.iconClassName, metadata = _a.metadata, onClickCloseButton = _a.onClickCloseButton, theme = _a.theme, remainingProps = __rest(_a, ["actions", "children", "className", "enableCloseButton", "fullWidth", "iconColor", "iconFamily", "iconName", "iconSize", "iconClassName", "metadata", "onClickCloseButton", "theme"]);
    return (React__default['default'].createElement("div", __assign({}, remainingProps, utilsCommons.parseMetadata(metadata), { className: classnames__default['default'](styles$2.alertContainer, className), ref: ref }),
        React__default['default'].createElement("div", { className: classnames__default['default'](styles$2.alertInner, styles$2["alertInner-" + theme], (_b = {},
                _b[styles$2.alertFullWidth] = fullWidth,
                _b)) },
            React__default['default'].createElement("div", { className: styles$2.alertContent },
                React__default['default'].createElement("span", { className: classnames__default['default'](styles$2.icon, iconClassName) },
                    React__default['default'].createElement(Icon__default['default'], { theme: theme, name: iconName !== null && iconName !== void 0 ? iconName : (_d = utilsCommons.ICON_MAP[theme]) === null || _d === void 0 ? void 0 : _d.name, color: iconColor !== null && iconColor !== void 0 ? iconColor : utilsCommons.THEME_COLOR_TOKEN_MAP[theme], size: iconSize, type: iconFamily })),
                children && (React__default['default'].createElement("div", { className: classnames__default['default'](styles$2.alertBodyContainer, (_c = {},
                        _c[styles$2.alertFullWidth] = fullWidth,
                        _c)) },
                    React__default['default'].createElement("div", null,
                        " ",
                        children))),
                enableCloseButton && (React__default['default'].createElement(Button__default['default'], { className: styles$2.alertCloseButton, onClick: onClickCloseButton, type: "button", icon: "times" }))),
            actions && React__default['default'].createElement(Actions, null, actions))));
}
AlertWithRef.displayName = 'Alert';
var Alert = React__default['default'].forwardRef(AlertWithRef);

var styles$1 = {"alertContainer":"InlineAlert-module__3yudcjyR__v1-0-1","horizontalStack":"InlineAlert-module__pudaEvUf__v1-0-1","cursorPointer":"InlineAlert-module__3y7JOPls__v1-0-1","supportText":"InlineAlert-module__haG6uylw__v1-0-1"};

var styles = {"popover":"InlineAlertPopover-module__23RSmjlR__v1-0-1"};

function InlineAlertPopover(_a, ref) {
    var children = _a.children, style = _a.style, closeCallback = _a.closeCallback, restProps = __rest(_a, ["children", "style", "closeCallback"]);
    var onClickOutsideRef = utilsHooks.useClickOutside(closeCallback);
    var listRef = utilsHooks.useForkRef([ref, onClickOutsideRef]);
    return (React__default['default'].createElement("div", __assign({ ref: listRef, style: style, className: styles.popover }, restProps), children));
}
var InlineAlertPopover$1 = React__default['default'].forwardRef(InlineAlertPopover);

function InlineAlertWithRef(_a, ref) {
    var _b;
    var _c;
    var children = _a.children, metadata = _a.metadata, status = _a.status, iconColor = _a.iconColor, iconFamily = _a.iconFamily, iconName = _a.iconName, iconSize = _a.iconSize, iconClassName = _a.iconClassName, popoverContent = _a.popoverContent, _d = _a.popoverPlacement, popoverPlacement = _d === void 0 ? 'bottom-start' : _d;
    var _e = React.useState(false), isPopoverVisible = _e[0], setPopoverVisibility = _e[1];
    var _f = utilsHooks.useAutoPositioner({
        placement: popoverPlacement,
    }), setReferenceElement = _f.setReferenceElement, setPopperElement = _f.setPopperElement, popperStyles = _f.styles.popper, attributes = _f.attributes;
    return (React__default['default'].createElement("div", __assign({ ref: ref, className: styles$1.alertContainer }, utilsCommons.parseMetadata(metadata)),
        React__default['default'].createElement("div", { ref: setReferenceElement, className: classnames__default['default'](styles$1.horizontalStack, (_b = {},
                _b[styles$1.cursorPointer] = popoverContent,
                _b)), onClick: function () {
                if (isPopoverVisible) {
                    return;
                }
                setPopoverVisibility(true);
            } },
            React__default['default'].createElement("span", { className: iconClassName },
                React__default['default'].createElement(Icon__default['default'], { theme: status, name: iconName !== null && iconName !== void 0 ? iconName : (_c = utilsCommons.ICON_MAP[status]) === null || _c === void 0 ? void 0 : _c.name, color: iconColor !== null && iconColor !== void 0 ? iconColor : utilsCommons.THEME_COLOR_TOKEN_MAP[status], size: iconSize !== null && iconSize !== void 0 ? iconSize : 16, type: iconFamily !== null && iconFamily !== void 0 ? iconFamily : 'solid' })),
            children && React__default['default'].createElement("div", { className: styles$1.supportText }, children)),
        popoverContent && isPopoverVisible && (React__default['default'].createElement(utilsPortalManager.GroupedPortal, null,
            React__default['default'].createElement(InlineAlertPopover$1, __assign({ closeCallback: function () {
                    setPopoverVisibility(false);
                }, ref: setPopperElement, style: popperStyles }, attributes.popper), popoverContent)))));
}
InlineAlertWithRef.displayName = 'InlineAlert';
var InlineAlert = React__default['default'].forwardRef(InlineAlertWithRef);

exports.Alert = Alert;
exports.InlineAlert = InlineAlert;
//# sourceMappingURL=index.js.map
